# Depth-wise convolution based network for for Semantic Segmentaion

This is the detection code for paper [demystifying local vision transformer](https://arxiv.org/pdf/2106.04263.pdf). It is based on based on [mmsegmentaion](https://github.com/open-mmlab/mmsegmentation).

## Results and Models

### ADE20K

| Backbone | Pretrain | Lr Schd | mIoU | #params | FLOPs | config | model |
| :---: | :---: | :---: | :---: | :---: | :---: | :---: | :---: |
| DWNet-T | ImageNet-1K | 160K | 45.5 | 56M | 928G | [config](configs/dwnet/upernet_dwnet_tiny_patch4_window7_512x512_160k_ade20k.py) | [github](https://github.com/Atten4Vis/DemystifyLocalViT/releases/download/prerelease/upernet_dwnet_tiny.pth)|
| DWNet-B | ImageNet-1K | 160K | 48.3 | 108M | 1129G | [config](configs/dwnet/upernet_dwnet_base_patch4_window7_512x512_160k_ade20k.py) | [github](https://github.com/Atten4Vis/DemystifyLocalViT/releases/download/prerelease/upernet_dwnet_base.pth)|
| Dynamic-DWNet-T | ImageNet-1K | 160K | 45.7 | 83M | 928G | [config](configs/dwnet/upernet_dynamic_dwnet_tiny_patch4_window7_512x512_160k_ade20k.py) | [github](https://github.com/Atten4Vis/DemystifyLocalViT/releases/download/prerelease/upernet_dynamic_dwnet_tiny.pth)|
| Dynamic-DWNet-B | ImageNet-1K | 160K | 48.0 | 195M | 1129G | [config](configs/dwnet/upernet_dynamic_dwnet_base_patch4_window7_512x512_160k_ade20k.py) | [github](https://github.com/Atten4Vis/DemystifyLocalViT/releases/download/prerelease/upernet_dynamic_dwnet_base.pth)|

**Notes**: 

- **Pre-trained models can be downloaded from [ImageNet Classification](#)**.


## Usage

### Installation

Please refer to [get_started.md](https://github.com/open-mmlab/mmsegmentation/blob/master/docs/get_started.md#installation) for installation and dataset preparation.

### Inference
```
# single-gpu testing
python tools/test.py <CONFIG_FILE> <SEG_CHECKPOINT_FILE> --eval mIoU

# multi-gpu testing
tools/dist_test.sh <CONFIG_FILE> <SEG_CHECKPOINT_FILE> <GPU_NUM> --eval mIoU

# multi-gpu, multi-scale testing
tools/dist_test.sh <CONFIG_FILE> <SEG_CHECKPOINT_FILE> <GPU_NUM> --aug-test --eval mIoU
```

### Training

To train with pre-trained models, run:
```
# single-gpu training
python tools/train.py <CONFIG_FILE> --options model.pretrained=<PRETRAIN_MODEL> [model.backbone.use_checkpoint=True] [other optional arguments]

# multi-gpu training
tools/dist_train.sh <CONFIG_FILE> <GPU_NUM> --options model.pretrained=<PRETRAIN_MODEL> [model.backbone.use_checkpoint=True] [other optional arguments] 
```
